rte_pdump.h(3)

NAME
rte_pdump.h

SYNOPSIS

#include <stdint.h>
#include <rte_bpf.h>

  Data Structures

struct rte_pdump_stats

  Functions

int rte_pdump_init (void)
int rte_pdump_uninit (void)
int rte_pdump_enable (uint16_t port, uint16_t queue, uint32_t flags, struct rte_ring *ring, struct rte_mempool *mp, void *filter)
int rte_pdump_enable_bpf (uint16_t port_id, uint16_t queue, uint32_t flags, uint32_t snaplen, struct rte_ring *ring, struct rte_mempool *mp, const struct rte_bpf_prm *prm)
int rte_pdump_disable (uint16_t port, uint16_t queue, uint32_t flags)
int rte_pdump_enable_by_deviceid (char *device_id, uint16_t queue, uint32_t flags, struct rte_ring *ring, struct rte_mempool *mp, void *filter)
int rte_pdump_enable_bpf_by_deviceid (const char *device_id, uint16_t queue, uint32_t flags, uint32_t snaplen, struct rte_ring *ring, struct rte_mempool *mp, const struct rte_bpf_prm *filter)
int rte_pdump_disable_by_deviceid (char *device_id, uint16_t queue, uint32_t flags)
int rte_pdump_stats (uint16_t port_id, struct rte_pdump_stats *stats)

Detailed Description

RTE pdump

packet dump library to provide packet capturing support on dpdk.

Definition in file rte_pdump.h.

Function Documentation

  int rte_pdump_init (void )
Initialize packet capturing handling

Register the IPC action for communication with target (primary) process.

Returns
    0 on success, -1 on error

  int rte_pdump_uninit (void )
Un initialize packet capturing handling

Unregister the IPC action for communication with target (primary) process.

Returns
    0 on success, -1 on error

  int rte_pdump_enable (uint16_t port, uint16_t queue, uint32_t flags, struct rte_ring * ring, struct rte_mempool * mp, void * filter)
Enables packet capturing on given port and queue.

Parameters
    port port on which packet capturing should be enabled.
    queue queue of a given port on which packet capturing should be enabled. users should pass on value UINT16_MAX to enable packet capturing on all queues of a given port.
    flags flags specifies RTE_PDUMP_FLAG_RX/RTE_PDUMP_FLAG_TX/RTE_PDUMP_FLAG_RXTX on which packet capturing should be enabled for a given port and queue.
    ring ring on which captured packets will be enqueued for user.
    mp mempool on to which original packets will be mirrored or duplicated.
    filter Unused should be NULL.

Returns
    0 on success, -1 on error, rte_errno is set accordingly.

  int rte_pdump_enable_bpf (uint16_t port_id, uint16_t queue, uint32_t flags, uint32_t snaplen, struct rte_ring * ring, struct rte_mempool * mp, const struct rte_bpf_prm * prm)
Enables packet capturing on given port and queue with filtering.

Parameters
    port_id The Ethernet port on which packet capturing should be enabled.
    queue The queue on the Ethernet port which packet capturing should be enabled. Pass UINT16_MAX to enable packet capturing on all queues of a given port.
    flags Pdump library flags that specify direction and packet format.
    snaplen The upper limit on bytes to copy. Passing UINT32_MAX means capture all the possible data.
    ring The ring on which captured packets will be enqueued for user.
    mp The mempool on to which original packets will be mirrored or duplicated.
    prm Use BPF program to run to filter packes (can be NULL)

Returns
    0 on success, -1 on error, rte_errno is set accordingly.

  int rte_pdump_disable (uint16_t port, uint16_t queue, uint32_t flags)
Disables packet capturing on given port and queue.

Parameters
    port port on which packet capturing should be disabled.
    queue queue of a given port on which packet capturing should be disabled. users should pass on value UINT16_MAX to disable packet capturing on all queues of a given port.
    flags flags specifies RTE_PDUMP_FLAG_RX/RTE_PDUMP_FLAG_TX/RTE_PDUMP_FLAG_RXTX on which packet capturing should be enabled for a given port and queue.

Returns
    0 on success, -1 on error, rte_errno is set accordingly.

  int rte_pdump_enable_by_deviceid (char * device_id, uint16_t queue, uint32_t flags, struct rte_ring * ring, struct rte_mempool * mp, void * filter)
Enables packet capturing on given device id and queue. device_id can be name or pci address of device.

Parameters
    device_id device id on which packet capturing should be enabled.
    queue queue of a given device id on which packet capturing should be enabled. users should pass on value UINT16_MAX to enable packet capturing on all queues of a given device id.
    flags flags specifies RTE_PDUMP_FLAG_RX/RTE_PDUMP_FLAG_TX/RTE_PDUMP_FLAG_RXTX on which packet capturing should be enabled for a given port and queue.
    ring ring on which captured packets will be enqueued for user.
    mp mempool on to which original packets will be mirrored or duplicated.
    filter unused should be NULL

Returns
    0 on success, -1 on error, rte_errno is set accordingly.

  int rte_pdump_enable_bpf_by_deviceid (const char * device_id, uint16_t queue, uint32_t flags, uint32_t snaplen, struct rte_ring * ring, struct rte_mempool * mp, const struct rte_bpf_prm * filter)
Enables packet capturing on given device id and queue with filtering. device_id can be name or pci address of device.

Parameters
    device_id device id on which packet capturing should be enabled.
    queue The queue on the Ethernet port which packet capturing should be enabled. Pass UINT16_MAX to enable packet capturing on all queues of a given port.
    flags Pdump library flags that specify direction and packet format.
    snaplen The upper limit on bytes to copy. Passing UINT32_MAX means capture all the possible data.
    ring The ring on which captured packets will be enqueued for user.
    mp The mempool on to which original packets will be mirrored or duplicated.
    filter Use BPF program to run to filter packes (can be NULL)

Returns
    0 on success, -1 on error, rte_errno is set accordingly.

  int rte_pdump_disable_by_deviceid (char * device_id, uint16_t queue, uint32_t flags)
Disables packet capturing on given device_id and queue. device_id can be name or pci address of device.

Parameters
    device_id pci address or name of the device on which packet capturing should be disabled.
    queue queue of a given device on which packet capturing should be disabled. users should pass on value UINT16_MAX to disable packet capturing on all queues of a given device id.
    flags flags specifies RTE_PDUMP_FLAG_RX/RTE_PDUMP_FLAG_TX/RTE_PDUMP_FLAG_RXTX on which packet capturing should be enabled for a given port and queue.

Returns
    0 on success, -1 on error, rte_errno is set accordingly.

  int rte_pdump_stats (uint16_t port_id, struct rte_pdump_stats * stats)
Retrieve the packet capture statistics for a queue.

Parameters
    port_id The port identifier of the Ethernet device.
    stats A pointer to structure of type rte_pdump_stats to be filled in.

Returns
    Zero if successful. -1 on error and rte_errno is set.

Author

Generated automatically by Doxygen for DPDK from the source code.